#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>
#include <string.h>
#include <iostream.h>

#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <fcntl.h>


#include "vorbisenc.h"
#include "generic.h"

void getargs(int argc, char** argv, VorbisEncode *vv);
void decode(char *str, Stream *stream);

int main(int argc, char** argv) {
  
  int tmp, bufsize, ossdev;
  short abuf[READ];
  int quality;
  int chans;
  int srate;
  char tempchar[128];
  char *pass;

  VorbisEncode *ve = new VorbisEncode();
  Stream *ptr;

  //  if (argc < 2)
  //usage(argv[0]);

  getargs(argc, argv, ve);

  cout << "type in a quality setting:" << endl;
  cin >> quality;
  cout << "how many channels of audio - 1, mono or 2, stereo:" << endl;
  cin >> chans;
  cout << "audio sample rate (44100, 22050, 11025, etc):" << endl;
  cin >> srate;


  if ( ( ossdev = open("/dev/dsp", O_RDWR) )  < 0 ) 
    exit(1);

  tmp=chans -1;
  if ( ioctl(ossdev,SNDCTL_DSP_STEREO,&tmp) == -1)
    fprintf(stderr,"Failed to set number of channels on sound device\n"); 
  tmp=16; 
  if ( ioctl(ossdev,SNDCTL_DSP_SAMPLESIZE,&tmp) == -1)
    fprintf(stderr,"Failed to set sample size on sound device\n");
  tmp=srate;
  if (ioctl(ossdev,SNDCTL_DSP_SPEED, &tmp) ==-1) 
    fprintf(stderr,"Failed to set samplerate on sound device\n");
  tmp=AFMT_S16_LE;
  if(ioctl(ossdev,SNDCTL_DSP_SETFMT,&tmp)==-1)
    fprintf(stderr,"failed to set data format on sound device\n");
 
  ve->OpenOutfile("save.ogg");   //ve->set_savefile("save.ogg");
  //ve->set_bitrate(32000);
  ve->set_channels(chans);
  ve->set_samplerate(srate);
  ve->set_save(true);

  fprintf(stderr, "encoding at %dKhz, %d Channels\n", ve->get_samplerate(), ve->get_channels());


  ptr = ve->get_first_stream();
  while (ptr != NULL) {
    //cout << "password for server: " << ptr->get_ip() <<":" <<ptr->get_port()<< "/" << ptr->get_mount() << endl;
    sprintf(tempchar,"password for server: %s:%d/%s\n", ptr->get_ip(),ptr->get_port(), ptr->get_mount());
    pass = getpass(tempchar);
    ptr->set_pass(pass);
    ptr = ptr->next_stream;
  }


  //  encoder init
  ve->Init();


  while (1) {
    read(ossdev, (char *)abuf, READ);
    ve->Encode((char*)abuf, READ, ve->get_channels());
    //write(ossdev, abuf, READ);
  }
  close(ossdev);
  return 0;
}

void decode(char *str, Stream *stream) {
  char *p;
  char tmp[128];
  int i =0;

  p = str;
  while(*p!='/') {
    p++;
  }
  p++;
  while(*p!='/') {
    p++;
  }
  //got past http://
  p++;
  i=0;
  
  while (*p!=':') {
    tmp[i] = *p;
    p++;
    i++;
  }  
  tmp[i]= '\0';
  stream->set_ip(tmp);
  p++;
  i=0;
  while (*p!='/') {
    tmp[i] = *p;
    p++;
    i++;
  }  
  tmp[i]= '\0';
  stream->set_port(atoi(tmp));
  p++;
  i=0;
  while (*p!='\0') {
    tmp[i] = *p;
    p++;
    i++;
  }
  tmp[i]= '\0';
  stream->set_mount(tmp);

}

void getargs(int argc, char** argv, VorbisEncode *vv) {
  int i;

  for (i=1; i< argc; i++) {
    decode(argv[i], vv->AddStream());
  }
  
}
